import re
import aiohttp
from pyrogram.types import InlineKeyboardButton


class Task:
    @staticmethod
    async def get_json(link):
        async with aiohttp.ClientSession() as session:
            async with session.get(link) as resp:
                return await resp.json()
                
                
    @staticmethod
    async def get_json_from_text(link):
        async with aiohttp.ClientSession() as session:
            async with session.get(link) as resp:
                text = await resp.text()
                return json.loads(text)
                

    def add_task(self, func):
        return self.loop.create_task(func())


    def get_link(self, string):
        regex = r"(?i)\b((?:https?://|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'\".,<>?«»“”‘’]))"
        url = re.findall(regex,string)   
        try:
            link = [x[0] for x in url][0]
            if link:
                return link
            else:
                return False
        except Exception:
            return False


    def gen_buttons(self, string):
        buttons = []
        rows = string.split("\n")
        for row in rows:
            row_buttons = []
            r_b = row.split("|")
            for b in r_b:
                data = b.split("-")
                text = data[0]
                while text.startswith(" "):
                    text = text[1:]
                while text.endswith(" "):
                    text = text[:-1]
                url = data[1]
                while url.startswith(" "):
                    url = url[1:]
                while url.endswith(" "):
                    url = url[:-1]
                row_buttons.append(InlineKeyboardButton(text, url=url))
            buttons.append(row_buttons)
        return buttons
